/**************************************************************
 * Send any comments or questions to: OTSO-Bug@tel.vtt.fi
 *
 * Name: /home/users/otso/official/otso/include/SCCS/s.int.hxx
 * Vers: 5.2    Time: 92/08/03, 15:42:01
 **************************************************************/

/***************************************************************
* Copyright (c) 1992      Technical Research Centre of Finland (VTT)
*
* Permission to use, copy, modify, and distribute this software and its
* documentation for any purpose and without fee is hereby granted, provided
* that this notice and the reference to this notice appearing in each software
* module be retained unaltered, and that the name of any contributors shall not
* be used in advertising or publicity pertaining to distribution of the software
* without specific written prior permission.  No contributor makes any
* representations about the suitability of this software for any purpose.
* It is provided "as is" without any express or limited warranty.
*
*			NO WARRANTY
*
* ALL CONTRIBUTORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS.  IN NO
* EVENT SHALL ANY CONTRIBUTOR BE LIABLE FOR ANY SPECIAL, PUNITIVE, INDIRECT OR
* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
* DATA, OR PROFITS, WHETHER IN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
* TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH, THE USE OR PERFORMANCE
* OF THIS SOFTWARE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THIS
* SOFTWARE IS WITH YOU.  SHOULD THIS SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE
* COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
*
* As used above, "contributor" includes, but is not limited to :
*        The Technical Research Centre of Finland
***************************************************************/


/**********************************************************************
* NAME
*	int.hxx
*
* PURPOSE
*	An Integer Class.
*
* BUGS
* MODIFICATIONS
**********************************************************************/

/**********************************************************************
class Int acts much like an sint32.
Additional value: isEmpty() 
and the chance to define derived classes for special purposes
(such as limited range, for example).

**********************************************************************/

class Int : public Object 
                        //Future work: Int could be derived from nothing 
                        //in order to save space.
{
public:
  sint32		value() const		{return val;}
                                                //the value
                        operator sint32()	{return val;}
  virtual boolean 	isEmpty();		//True if default constructor
                                                //used and not assigned.
                                                //true after reset().
  virtual void		reset();		//Makes this empty,
                                                //value is lost.

  virtual void		print(Ostream& os);
  virtual void		ask(Istream& is);
  virtual void		to(ODump&);
  virtual void		from(IDump&);
  virtual String 	className() const;

  Int(sint32 i);				//not empty, value i
  Int();					//Will be empty until 
                                                //something assigned to this.

protected:
  sint32		val;			//the value
  boolean		hasVal;			//if true, val has been set
                                                //(it is not garbage)
};


