/**************************************************************
 * Send any comments or questions to: OTSO-Bug@tel.vtt.fi
 *
 * Name: /home/users/otso/official/otso/tools/SCCS/s.ppp.c
 * Vers: 5.2    Time: 92/08/05, 14:47:14
 **************************************************************/

#ifdef SCCS_ID
/* for Unix 'what' command */
static char sccs_id[] = "@(#)ppp.c	5.2 92/08/05";
#endif

/***************************************************************
* Copyright (c) 1992      Technical Research Centre of Finland (VTT)
*
* Permission to use, copy, modify, and distribute this software and its
* documentation for any purpose and without fee is hereby granted, provided
* that this notice and the reference to this notice appearing in each software
* module be retained unaltered, and that the name of any contributors shall not
* be used in advertising or publicity pertaining to distribution of the software
* without specific written prior permission.  No contributor makes any
* representations about the suitability of this software for any purpose.
* It is provided "as is" without any express or limited warranty.
*
*			NO WARRANTY
*
* ALL CONTRIBUTORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS.  IN NO
* EVENT SHALL ANY CONTRIBUTOR BE LIABLE FOR ANY SPECIAL, PUNITIVE, INDIRECT OR
* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
* DATA, OR PROFITS, WHETHER IN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
* TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH, THE USE OR PERFORMANCE
* OF THIS SOFTWARE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THIS
* SOFTWARE IS WITH YOU.  SHOULD THIS SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE
* COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
*
* As used above, "contributor" includes, but is not limited to :
*        The Technical Research Centre of Finland
***************************************************************/


#include <stdio.h>

/*
 * NAME
 *	dvops prepro's pre-processor :-) :-).
 *
 * PURPOSE
 *	- Strips out leading linefeeds, and
 *	- Converts " #include", " #define", etc 'cpp' directives
 *	  to       "#include",  "#define",  etc.
 *        i.e. removes leading blank before #.
 *
 * USAGE
 *     To create .hx files from .hxpp files.
 *	1. file.asn -> casn -> file.hxpp
 *	2. /usr/lib/cpp -P file.hxpp | ppp > file.hx
 *	3. prepro < file.hx > file.hxx
 *
 */

main ()
{
#define LEN 1000
    char buffer[LEN], * s;
    char eat_linefeeds = 1;	/* eat leading newlines */

    while (s = fgets(buffer, LEN-1, stdin)) {
        if (*s == '\n' && eat_linefeeds) ;	/* eat leading white space */
	    
        else if (*s == ' ' && *(s+1) == '#') {
            fputs(++s, stdout);
        }

	else {
            if (eat_linefeeds)
                fputs ("\n", stdout);
            eat_linefeeds = 0;
            fputs(s, stdout);
	}
    }
}
